<?php
include "config.php" ;
include "master.php" ;
include "relay.php" ;
include "drivers.php" ;
include "drivers_custom.php" ;
include "functions.php" ;
include "output.php" ;

// check arguments
$datafile = "" ;
$savefile = "" ;
$isResume = FALSE ;
$data_hz = 60 ;
$skip = 0 ;
$data_udp = TRUE ;
$flag_restart = FALSE ;
$flag_sw_best_kph = FALSE ;
$flag_sync = FALSE ;
if( array_key_exists("3", $argv ) ) {
  $datafile = $argv[1] ;
  $data_hz = $argv[2] ;
  $skip = $argv[3] ;

  if( !file_exists( $datafile ) ) {
    die() ;
  }
  if( $data_hz < 0 || $data_hz > 6000 ) {
    die() ;
  }
  if( $skip < 0 || $skip > 648000 ) {
    die() ;
  }
  $data_udp = FALSE ;
} elseif( array_key_exists("1", $argv ) ) {
  $savefile = $argv[1] ;
  if( !file_exists( $savefile ) ) {
    die() ;
  }
  $isResume = TRUE ;
}
$sleep_base = floor( 1000000 / $data_hz / 0.7 ) ;

// init data
$wDataMst = initWDataMst() ;

// create UDP socket
if( $data_udp ) {
  $sockRcv = socket_create( AF_INET, SOCK_DGRAM, SOL_UDP ) ;
  socket_bind( $sockRcv, $localhost, $listenPort ) ;
} else {
  $fpi = fopen( $datafile, "r" ) ;
  if( $skip > 0 ) {
    fseek( $fpi, $skip * PACKET_SIZE ) ;
    if( feof($fpi) ) {
      die() ;
    }
  }
}

// open shared memory
$shmid = shmop_open( SHM_ID, 'c', 0644, SHM_SIZE ) ;
// main loop
echoTitle( $data_udp, $localhost, $listenPort, $datafile ) ;
if( $isResume ) {
  echo "resume session from $savefile\n" ;
}
$fpo = NULL ;
$prev_time = microtime( true ) ;
while( true ) {
  // create relay socket
  $sockSend = array() ;
  for( $i=0 ; $i<sizeof($relayList) ; $i++ ) {
    $sockSend[] = socket_create( AF_INET, SOCK_DGRAM, SOL_UDP ) ;
  }

  // sub loop
if( DEBUG_ON && $DEBUG_MODE ) {
$debug_time_php_max = 0 ;
$debug_time_php_all = 0 ;
$debug_time_udp_max = 0 ;
$debug_time_udp_all = 0 ;
}
  for( $j=0 ; $j<300 ; $j++ ) {
    // recieve UDP
    if( $data_udp ) {
if( DEBUG_ON && $DEBUG_MODE ) {
$debug_time_udp_start = microtime( TRUE ) ;
}
      $bytes = socket_recvfrom( $sockRcv, $buf, 4096, 0, $from, $port ) ;
if( DEBUG_ON && $DEBUG_MODE ) {
$debug_time_udp = microtime( TRUE ) - $debug_time_udp_start ;
$debug_time_udp_all += $debug_time_udp ;
if( $debug_time_udp > $debug_time_udp_max ) {
  $debug_time_udp_max = $debug_time_udp ;
}
}
    } else {
      if( !feof($fpi) ) {
        $buf = fread( $fpi, PACKET_SIZE ) ;
        $time = microtime( TRUE ) ;
        $stime = $sleep_base - (($time - $prev_time) * 1000000.0) ;
        if( $stime > 0 ) {
          usleep( floor($stime) ) ;
        } else {
          usleep( $sleep_base ) ;
        }
        $prev_time = microtime( TRUE ) ;
      } else {
        fclose( $fpi ) ;
        break 2 ;
      }
    }
if( DEBUG_ON && $DEBUG_MODE ) {
$debug_time_php_start = microtime( TRUE ) ;
}
    $sz = strlen($buf) ;
    // commands
    if( $sz == CMD_SIZE ) {
      // bye
      if( strcmp($buf, CMD_BYE) == 0 ) {
        break 2 ;
      }
      // restart
      if( strcmp($buf, CMD_RESTART) == 0 ) {
        $flag_restart = TRUE ;
        // flush telemetry data buffer
        if( $isSaveData && $fpo !== NULL ) {
          fwrite( $fpo, $wbuf, strlen($wbuf) ) ;
          flush() ;
          fclose( $fpo ) ;
          $fpo = NULL ;
        }
        // init shared memory
        shmop_delete( $shmid ) ;
        $shmid = shmop_open( SHM_ID, 'c', 0644, SHM_SIZE ) ;
        continue ;
      }
      // switch best / kph
      if( strcmp($buf, CMD_SW_BEST_KPH) == 0 && $wDataMst["m_time"] > 0 ) {
        $SPDDISP_FLAG = 1 - $SPDDISP_FLAG ;
        $st = $wData["m_sessionType"] ; // sessionType
        $ts = $wData["m_track_size"] ; // track size(length)
        $rpos = makeRacePositionData( $wData, $cData ) ;
        $tpos = makeTrackPositionData( $st, $ts, $rpos, $wData, $cData, $cDataMst ) ;
        outputHtml( $shmid, $rpos, $tpos, $wData, $cData, $wDataMst, $cDataMst ) ;
        
        continue ;
      }
      continue ;
    }
    // illegal packet
    if( $sz != PACKET_SIZE ) {
      break 2 ;
    }

    // relay
    for( $i=0 ; $i<sizeof($relayList) ; $i++ ) {
      $ip = getArray( $relayList[$i], 'ip' ) ;
      $port = getArray( $relayList[$i], 'port' ) ;
      if( $ip !=0 && $port != 0 ) {
        socket_sendto( $sockSend[$i], $buf, strlen($buf), 0, $ip, $port ) ;
      }
    }

    // unpack and extract
    $ud = unpack($UNPACK_FORMAT, $buf) ;
    $wData = getWData( $ud ) ;
    $cData = getCData( $ud, CARS_MAX ) ;

    // main function
    if( $wData["m_track_number"] != $wDataMst["m_track_number"]  ||
        $wData["m_sessionType"] != $wDataMst["m_sessionType"] ||
        $wData["m_time"] < $wDataMst["m_time"] ||
        $flag_restart
    ) {
      $flag_restart = FALSE ;
      // change track or change session or restart session
      if( $isResume ) {
        // resume session
        $isResume = FALSE ;
        $arr = unserialize( file_get_contents($savefile) ) ;
        $wDataMst = getArray( $arr, "wDataMst" ) ;
        $cDataMst = getArray( $arr, "cDataMst" ) ;
        if( sizeof($cDataMst) == CARS_MAX ) {
          $wDataMst["m_time"] = $wData["m_time"] ;
          echo "resume success!\n" ;
        } else {
          echo "resume failed\n" ;
          startSession( $wData, $cData, $wDataMst, $cDataMst ) ;
        }
      } else {
        // start session
        startSession( $wData, $cData, $wDataMst, $cDataMst ) ;
      }
      $flag_sync = FALSE ;
      $sdd = array() ;
      $datestr = date("YmdHis") ;
      $track = $TRACKS[$wData["m_track_number"]] ;
      $st = $wData["m_sessionType"] ;
      $sid = substr( $SESSION_TYPE[$st], 0, 1 ) ;
      $savefile = sprintf( "data/%s_%s_%s.sav", $datestr, $track, $sid ) ;
      if( $data_udp && $isSaveData) {
        // flush telemetry data buffer
        if( $fpo !== NULL ) {
          fwrite( $fpo, $wbuf, strlen($wbuf) ) ;
          flush() ;
          fclose( $fpo ) ;
          $fpo = NULL ;
        }
        $tlmfile = sprintf( "data/%s_%s_%s.dat", $datestr, $track, $sid ) ;
        $fpo = fopen( $tlmfile, "w" ) ;
        $wbuf = "" ;
      }
/*
print_r( $cData ) ;
print_r( $cDataMst ) ;
*/
    }
    if( $wData["m_time"] >= $wDataMst["m_time"] ) {
      if( $data_udp && $isSaveData ) {
        $wbuf .= $buf ;
        if( strlen($wbuf) >= PACKET_SIZE * 300 ) {
          fwrite( $fpo, $wbuf, strlen($wbuf) ) ;
          $wbuf = "" ;
        }
      }
      // update status
$t = microtime(true) ;
      updateStatus( $shmid, $wData, $cData, $wDataMst, $cDataMst ) ;
$t2 = microtime(true) - $t ;
if( $t2 > 0.008 ) { addDebugMsg( (sprintf("[updateStatus()] %.3f\n", $t2 )) ) ; }
    }
if( DEBUG_ON && $DEBUG_MODE ) {
$debug_time_php = microtime( TRUE ) - $debug_time_php_start ;
$debug_time_php_all += $debug_time_php ;
if( $debug_time_php > $debug_time_php_max ) {
  $debug_time_php_max = $debug_time_php ;
}
}
  }
if( DEBUG_ON && $DEBUG_MODE ) {
$debugbuf = sprintf( "[Time] phpmax:%.7f, phpall:%.7f, udpmax:%.7f, udpall:%.7f\n", $debug_time_php_max, $debug_time_php_all, $debug_time_udp_max, $debug_time_udp_all ) ;
addDebugMsg( $debugbuf ) ;
}

  // sync driver data from online
  if( $USE_DRIVERS_CUSTOM && $USE_CHANNEL > 0 && $flag_sync === FALSE ) {
    $flag_sync = TRUE ;
    $sdd = syncDriverData( $wData["m_era"], $cData, $cDataMst ) ;
  }
  // close relay socket
  for( $i=0 ; $i<sizeof($relayList) ; $i++ ) {
    socket_close( $sockSend[$i] ) ;
  }
  // reload config
  reloadConfig( $sdd, $wData, $cData, $cDataMst ) ;
}

if( $data_udp ) {
  socket_close( $sockRcv ) ;
  // flush telemetry data buffer
  if( $isSaveData && $fpo !== NULL ) {
    fwrite( $fpo, $wbuf, strlen($wbuf) ) ;
    flush() ;
    fclose( $fpo ) ;
    $fpo = NULL ;
  }
}

// wait player
//echo "hit enter key to clear the browser screen\n" ;
echo "\nsave session data?(y/n):\n" ;
$buf = fgets( STDIN, 4096 ) ;
$c = substr( $buf, 0, 1 ) ;
if( strcmp($c,'y')==0 || strcmp($c,'Y')==0 ) {
  $arr = array(
    "wDataMst" => $wDataMst,
    "cDataMst" => $cDataMst,
  ) ;
  file_put_contents( $savefile, serialize($arr) ) ;
  echo "session data was saved to $savefile\n" ;
}
echo "\nbye\n" ;

// close
shmop_delete( $shmid ) ;
shmop_close( $shmid ) ;
?>
